import constants
import crypto

import getpass

def get_keyfile_data():
    keyfile_data = ""
    while not keyfile_data:
        password = get_password()
        try:
            keyfile_data = crypto.decrypt(password, 
                                            constants.SECRET_KEYFILE_PATH)
        except crypto.CryptoError:
            print "Failed to unlock keyfile; bad password?"
    return keyfile_data

def get_password(prompt="Password: ", confirm_prompt="Confirm: ",
                    err="Passwords did not match.\n", confirm=False):
    password = getpass.getpass(prompt)

    if confirm:
        while getpass.getpass(confirm_prompt) != password:
            print err
            password = getpass.getpass(prompt)

    return password

def get_yes_no_response(prompt, err="Invalid response.\n", yes="y", no="n"):
    response = ""
    while 1:
        response = raw_input(prompt)
        if    response == yes: return True
        elif  response == no:  return False
        else: print err
